// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: hibernate/HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.spatial;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Collection;
import java.util.HashSet;

/**
 * Présence d'un élément d'une liste du référentiel sur une ou plusieurs zones géographiques.
 * Une ou plusieurs géométrie (ponctuelle, linéraire ou polygonale) peuvent etre définies afin de
 * géolocaliser un des éléments d'une liste.
 * Une procédure stockée sous Oracle permet la mise à jour d'un lien vers le référentiel des lieux
 * (table SPATIAL_ITEM2LOCATION) à partir des géométries définies.
 */
// HibernateEntity.vsl annotations merge-point
public abstract class SpatialItem
    implements Serializable, Comparable<SpatialItem>
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = 1992571232686464187L;

    // Generate 3 attributes
    private Integer id;

    /**
     * Idenfiant interne. Généré par le système.
     * @return this.id Integer
     */
    public Integer getId()
    {
        return this.id;
    }

    /**
     * Idenfiant interne. Généré par le système.
     * @param idIn Integer
     */
    public void setId(Integer idIn)
    {
        this.id = idIn;
    }

    private Integer objectId;

    /**
     * 
     * @return this.objectId Integer
     */
    public Integer getObjectId()
    {
        return this.objectId;
    }

    /**
     * 
     * @param objectIdIn Integer
     */
    public void setObjectId(Integer objectIdIn)
    {
        this.objectId = objectIdIn;
    }

    private Timestamp updateDate;

    /**
     * 
     * @return this.updateDate Timestamp
     */
    public Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    /**
     * 
     * @param updateDateIn Timestamp
     */
    public void setUpdateDate(Timestamp updateDateIn)
    {
        this.updateDate = updateDateIn;
    }

    // Generate 5 associations
    private Collection<SpatialItem2Location> spatialItem2Locations = new HashSet<SpatialItem2Location>();

    /**
     * 
     * @return this.spatialItem2Locations Collection<SpatialItem2Location>
     */
    public Collection<SpatialItem2Location> getSpatialItem2Locations()
    {
        return this.spatialItem2Locations;
    }

    /**
     * 
     * @param spatialItem2LocationsIn Collection<SpatialItem2Location>
     */
    public void setSpatialItem2Locations(Collection<SpatialItem2Location> spatialItem2LocationsIn)
    {
        this.spatialItem2Locations = spatialItem2LocationsIn;
    }

    /**
     * 
     * @param elementToAdd SpatialItem2Location
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSpatialItem2Locations(SpatialItem2Location elementToAdd)
    {
        return this.spatialItem2Locations.add(elementToAdd);
    }

    /**
     * 
     * @param elementToRemove SpatialItem2Location
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSpatialItem2Locations(SpatialItem2Location elementToRemove)
    {
        return this.spatialItem2Locations.remove(elementToRemove);
    }

    private SpatialItemType spatialItemType;

    /**
     * Type de régionalisation d'une liste du réfétentiel.
     * Il peut y avoir plusieurs type de régionalisation pour une meme liste (pour un meme
     * OBJECT_TYPE_FK).
     * Par exemple :
     * - régionalisation des gradients de profondeur (utile pour les Antilles)
     * @return this.spatialItemType SpatialItemType
     */
    public SpatialItemType getSpatialItemType()
    {
        return this.spatialItemType;
    }

    /**
     * Type de régionalisation d'une liste du réfétentiel.
     * Il peut y avoir plusieurs type de régionalisation pour une meme liste (pour un meme
     * OBJECT_TYPE_FK).
     * Par exemple :
     * - régionalisation des gradients de profondeur (utile pour les Antilles)
     * @param spatialItemTypeIn SpatialItemType
     */
    public void setSpatialItemType(SpatialItemType spatialItemTypeIn)
    {
        this.spatialItemType = spatialItemTypeIn;
    }

    private Collection<SpatialItemLine> spatialItemLines = new HashSet<SpatialItemLine>();

    /**
     * 
     * @return this.spatialItemLines Collection<SpatialItemLine>
     */
    public Collection<SpatialItemLine> getSpatialItemLines()
    {
        return this.spatialItemLines;
    }

    /**
     * 
     * @param spatialItemLinesIn Collection<SpatialItemLine>
     */
    public void setSpatialItemLines(Collection<SpatialItemLine> spatialItemLinesIn)
    {
        this.spatialItemLines = spatialItemLinesIn;
    }

    /**
     * 
     * @param elementToAdd SpatialItemLine
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSpatialItemLines(SpatialItemLine elementToAdd)
    {
        return this.spatialItemLines.add(elementToAdd);
    }

    /**
     * 
     * @param elementToRemove SpatialItemLine
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSpatialItemLines(SpatialItemLine elementToRemove)
    {
        return this.spatialItemLines.remove(elementToRemove);
    }

    private Collection<SpatialItemPoint> spatialItemPoints = new HashSet<SpatialItemPoint>();

    /**
     * 
     * @return this.spatialItemPoints Collection<SpatialItemPoint>
     */
    public Collection<SpatialItemPoint> getSpatialItemPoints()
    {
        return this.spatialItemPoints;
    }

    /**
     * 
     * @param spatialItemPointsIn Collection<SpatialItemPoint>
     */
    public void setSpatialItemPoints(Collection<SpatialItemPoint> spatialItemPointsIn)
    {
        this.spatialItemPoints = spatialItemPointsIn;
    }

    /**
     * 
     * @param elementToAdd SpatialItemPoint
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSpatialItemPoints(SpatialItemPoint elementToAdd)
    {
        return this.spatialItemPoints.add(elementToAdd);
    }

    /**
     * 
     * @param elementToRemove SpatialItemPoint
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSpatialItemPoints(SpatialItemPoint elementToRemove)
    {
        return this.spatialItemPoints.remove(elementToRemove);
    }

    private Collection<SpatialItemArea> spatialItemAreas = new HashSet<SpatialItemArea>();

    /**
     * 
     * @return this.spatialItemAreas Collection<SpatialItemArea>
     */
    public Collection<SpatialItemArea> getSpatialItemAreas()
    {
        return this.spatialItemAreas;
    }

    /**
     * 
     * @param spatialItemAreasIn Collection<SpatialItemArea>
     */
    public void setSpatialItemAreas(Collection<SpatialItemArea> spatialItemAreasIn)
    {
        this.spatialItemAreas = spatialItemAreasIn;
    }

    /**
     * 
     * @param elementToAdd SpatialItemArea
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean addSpatialItemAreas(SpatialItemArea elementToAdd)
    {
        return this.spatialItemAreas.add(elementToAdd);
    }

    /**
     * 
     * @param elementToRemove SpatialItemArea
     * @return <tt>true</tt> if this collection changed as a result of the
     *         call
     */
    public boolean removeSpatialItemAreas(SpatialItemArea elementToRemove)
    {
        return this.spatialItemAreas.remove(elementToRemove);
    }

    /**
     * Returns <code>true</code> if the argument is an SpatialItem instance and all identifiers for this entity
     * equal the identifiers of the argument entity. Returns <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof SpatialItem))
        {
            return false;
        }
        final SpatialItem that = (SpatialItem)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    @Override
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (this.id == null ? 0 : this.id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link SpatialItem}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link SpatialItem}.
         * @return new SpatialItemImpl()
         */
        public static SpatialItem newInstance()
        {
            return new SpatialItemImpl();
        }

        /**
         * Constructs a new instance of {@link SpatialItem}, taking all required and/or
         * read-only properties as arguments, except for identifiers.
         * @param objectId Integer
         * @param spatialItemType SpatialItemType
         * @return newInstance
         */
        public static SpatialItem newInstance(Integer objectId, SpatialItemType spatialItemType)
        {
            final SpatialItem entity = new SpatialItemImpl();
            entity.setObjectId(objectId);
            entity.setSpatialItemType(spatialItemType);
            return entity;
        }

        /**
         * Constructs a new instance of {@link SpatialItem}, taking all possible properties
         * (except the identifier(s))as arguments.
         * @param objectId Integer
         * @param updateDate Timestamp
         * @param spatialItem2Locations Collection<SpatialItem2Location>
         * @param spatialItemType SpatialItemType
         * @param spatialItemLines Collection<SpatialItemLine>
         * @param spatialItemPoints Collection<SpatialItemPoint>
         * @param spatialItemAreas Collection<SpatialItemArea>
         * @return newInstance SpatialItem
         */
        public static SpatialItem newInstance(Integer objectId, Timestamp updateDate, Collection<SpatialItem2Location> spatialItem2Locations, SpatialItemType spatialItemType, Collection<SpatialItemLine> spatialItemLines, Collection<SpatialItemPoint> spatialItemPoints, Collection<SpatialItemArea> spatialItemAreas)
        {
            final SpatialItem entity = new SpatialItemImpl();
            entity.setObjectId(objectId);
            entity.setUpdateDate(updateDate);
            entity.setSpatialItem2Locations(spatialItem2Locations);
            entity.setSpatialItemType(spatialItemType);
            entity.setSpatialItemLines(spatialItemLines);
            entity.setSpatialItemPoints(spatialItemPoints);
            entity.setSpatialItemAreas(spatialItemAreas);
            return entity;
        }
    }

    /**
     * @see Comparable#compareTo
     */
    public int compareTo(SpatialItem o)
    {
        int cmp = 0;
        if (this.getId() != null)
        {
            cmp = this.getId().compareTo(o.getId());
        }
        else
        {
            if (this.getObjectId() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getObjectId().compareTo(o.getObjectId()));
            }
            if (this.getUpdateDate() != null)
            {
                cmp = (cmp != 0 ? cmp : this.getUpdateDate().compareTo(o.getUpdateDate()));
            }
        }
        return cmp;
    }
// HibernateEntity.vsl merge-point
// SpatialItem.java merge-point
}